﻿using System;
using System.Collections.Generic;
using System.Text;
using ESBasic.Helpers;

namespace Core
{
    [Serializable]
    public class ChatMsg:BaseMsg
    {      
        private string sourceUserID;
        /// <summary>
        /// 发送该消息的用户ID
        /// </summary>
        public string SourceUserID
        {
            get { return sourceUserID; }
            set { sourceUserID = value; }
        }
        private string targetUserID;
        /// <summary>
        /// 该消息所发往的用户ID
        /// </summary>
        public string TargetUserID
        {
            get { return targetUserID; }
            set { targetUserID = value; }
        }
        private DateTime timeSent;
        /// <summary>
        /// 该消息的发送时间
        /// </summary>
        public DateTime TimeSent
        {
            get { return timeSent; }
            set { timeSent = value; }
        }
        private string msgText;
        /// <summary>
        /// 该消息的文本内容        /// 
        /// </summary>
        public string MsgText
        {
            get { return msgText; }
            set { msgText = value; }
        }
        /// <summary>
        /// 构造一个ChatMsg实例
        /// </summary>
        /// <param name="_sourceUserID">该消息源用户ID</param>
        /// <param name="_targetUserID">该消息目标用户ID</param>
        /// <param name="_MsgText">该消息的文本内容   </param>
        public ChatMsg(string _sourceUserID, string _targetUserID, string _MsgText)
        {
            base.MsgType = Core.MsgType.Chatting;
            this.sourceUserID = _sourceUserID;
            this.targetUserID = _targetUserID;
            this.timeSent = DateTime.Now;
            this.msgText = _MsgText;
        }     
    }
}
