﻿using System;
using System.Collections.Generic;
using System.Text;

namespace Core
{
    public class MsgHead
    { 
        private int messageType;
        /// <summary>
        /// 消息类型
        /// </summary>
        public int MessageType
        {
            get { return messageType; }
            set { messageType = value; }
        }

        private int bodyLength;
        /// <summary>
        /// 消息体长度
        /// </summary>
        public int BodyLength
        {
            get { return bodyLength; }
            set { bodyLength = value; }
        }

        public const int HeadLength = 8;


        public MsgHead(int msgType,int bodyLen)
        {
            this.bodyLength = bodyLen;
            this.messageType = msgType;
        }

        public byte[] ToStream()
        {
            byte[] buff = new byte[MsgHead.HeadLength];
            byte[] bodyLenBuff = BitConverter.GetBytes(this.bodyLength);
            byte[] msgTypeBuff = BitConverter.GetBytes(this.messageType);
            Buffer.BlockCopy(msgTypeBuff, 0, buff, 0, msgTypeBuff.Length);
            Buffer.BlockCopy(bodyLenBuff, 0, buff, 4, bodyLenBuff.Length);
            return buff;
        }
    }
}
