﻿using System;
using System.Collections.Generic;
using System.Text;
using ESBasic.Helpers;

namespace Core
{
    public static class MsgHelper
    {
        /// <summary>
        /// 构建消息
        /// </summary>
        /// <param name="msgType">消息类型</param>
        /// <param name="msgBody">消息体</param>
        /// <returns></returns>
        public static byte[] BuildMsg(int msgType, Byte[] msgBody)
        {
            MsgHead msgHead = new MsgHead(msgType, msgBody.Length);
            //将消息头与消息体拼接起来
            byte[] msg = BufferJointer.Joint(msgHead.ToStream(), msgBody);
            return msg;
        }
      
        public static byte[] BuildMsg(int msgType, string str)
        {
            return MsgHelper.BuildMsg(msgType, Encoding.UTF8.GetBytes(str));
        }
        /// <summary>
        /// 将二进制数组还原成消息对象
        /// </summary>
        /// <typeparam name="T">所要还原成的消息类</typeparam>
        /// <param name="msg">消息数据</param>
        /// <returns></returns>
        public static T DeserializeMsg<T>(byte[] msg)
        {
            return (T)SerializeHelper.DeserializeBytes(msg, 8, msg.Length - 8);   
        }        
    }
}

