﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;
using System.Windows.Forms;
using Core;
using StriveEngine.Tcp.Passive;
using System.Net;

namespace StriveEngineChatDemo
{
    public partial class LoginForm : Form
    {       
        private ITcpPassiveEngine tcpPassiveEngine;
        private string selfID; 

        public string SelfID
        {
            get { return selfID; }           
        }                
        /// <summary>
        /// 构造方法
        /// </summary>
        /// <param name="_tcpPassiveEngine"></param>
        public LoginForm(ITcpPassiveEngine _tcpPassiveEngine)       
        {
            InitializeComponent();
            this.tcpPassiveEngine = _tcpPassiveEngine;
            this.tcpPassiveEngine.AutoReconnect = true;
            this.tcpPassiveEngine.MessageReceived += new StriveEngine.CbDelegate<System.Net.IPEndPoint, byte[]>(tcpPassiveEngine_MessageReceived);
            this.tcpPassiveEngine.Initialize();
        }

        #region 接收消息事件处理
        /// <summary>
        /// 接收消息事件处理 
        /// </summary>
        /// <param name="userAddress">消息源IP端口号</param>
        /// <param name="msg">消息</param>
        private void tcpPassiveEngine_MessageReceived(IPEndPoint userAddress, byte[] msg)
        {
            //取出消息类型
            int msgType = BitConverter.ToInt32(msg, 0);
            //验证消息类型
            if (msgType == MsgType.Logining)
            {
                LoginMsg loginMsg = MsgHelper.DeserializeMsg<LoginMsg>(msg);
                if (loginMsg.LogonResult == LogonResult.Succeed)
                {
                    this.DialogResult = DialogResult.OK;
                    this.tcpPassiveEngine.MessageReceived -= new StriveEngine.CbDelegate<System.Net.IPEndPoint, byte[]>(tcpPassiveEngine_MessageReceived);
                }
                if (loginMsg.LogonResult == LogonResult.Repetition)
                {
                    MessageBox.Show("登录失败，该账号已经登录！");
                }
            }
        } 
        #endregion
     
        private void button_login_Click(object sender, EventArgs e)
        {
            this.selfID = this.textBox_ID.Text.Trim();
            LoginMsg loginMsg = new LoginMsg(this.selfID);
            this.tcpPassiveEngine.PostMessageToServer(loginMsg.ToContractStream());     
        }       
    }
}
